import useClickMarker from "../../../hooks/useClickMarker";
import { checkScore } from "../../../domain/apiMethods";
import { useGameConfig } from "../../../hooks/useGameInfo";
import { useLastRound } from "../../../domain/gameStore";

const useClickToCheckScore = (mapRef, point1) => {
  const { scoreMethod } = useGameConfig();
  const { roundNum } = useLastRound();
  // when the map is clicked, call the scoring API and update the marker's title
  useClickMarker(mapRef, async (point2, marker) => {
    const { score } = await checkScore(point1, point2, scoreMethod, roundNum);
    marker.setLabel({
      fontWeight: "500",
      text: `Potential Score: ${score}`,
    });
  });
};

export default useClickToCheckScore;
